SystemOrganization addCategory: #'A4BP-core'!
SystemOrganization addCategory: 'A4BP-core-files'!
SystemOrganization addCategory: 'A4BP-core-log'!
SystemOrganization addCategory: 'A4BP-core-metric'!
SystemOrganization addCategory: 'A4BP-core-model'!
SystemOrganization addCategory: 'A4BP-core-model-collections'!
SystemOrganization addCategory: 'A4BP-core-parser'!
SystemOrganization addCategory: 'A4BP-core-parser-builder'!
SystemOrganization addCategory: 'A4BP-core-resources-download'!
SystemOrganization addCategory: 'A4BP-core-visitor'!

!XMLPI methodsFor: '*A4BP-core-parser' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:33'!
localName
	^ self name! !

!XMLPI methodsFor: '*A4BP-core-parser' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:48'!
namespaceScope
	^ A4BPXMLHelper new! !

!XMLElement methodsFor: '*A4BP-core' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 15:43'!
writeNamespaceDeclarationsOn: tagWriter
	self namespaceScope prefixMappings keysAndValuesDo:[ :k :n |
		tagWriter xmlnsAt: k put: n ].
	^ tagWriter.
! !

!XMLElement methodsFor: '*A4BP-core' stamp: 'AlvaroJosePeraltaOcampo 7/27/2014 00:34'!
writeXMLWithOutChildrenOn: aWriter
	| tagWriter |

	tagWriter := aWriter tag: self name.

	self hasNamespaces
		ifTrue: [self writeNamespaceDeclarationsOn: tagWriter].
	self hasAttributes 
		ifTrue: [
			self attributeNodes do: [:each |
				tagWriter attributeAt: each name put: each value]].
	^ tagWriter.
	"tagWriter with: [self writeInnerXMLOn: aWriter]."! !

Object subclass: #A4BPAbstractCollection
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model-collections'!

!A4BPAbstractCollection class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:24'!
annotation
<abstract>
<MSEClass: #A4BPAbstractCollection  super: #Object >
<package: #'A4BP-core' >! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:18'!
add: anObject
	^ collection add: anObject! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 4/13/2015 08:11'!
at: anKey
	^ collection collect:[ :e | e = anKey].! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:18'!
collect:aBlock
	^ collection collect:aBlock! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/12/2015 22:22'!
collect: aBlock as: value
	^ collection collect: aBlock as: value! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 16:19'!
collection
	^ collection! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 16:21'!
collection: anObject
	collection := anObject! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:18'!
do: aBlock
	collection do: aBlock! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:18'!
first
	^ collection values first! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:18'!
isCollection
	^ collection isCollection! !

!A4BPAbstractCollection methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 16:25'!
isEmpty
	^ self collection isEmpty ! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:19'!
select:aBlock
	^ collection select:aBlock! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 16:25'!
size
	^ self collection size! !

!A4BPAbstractCollection methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 16:25'!
values
	^ self collection values! !

A4BPAbstractCollection subclass: #A4BPCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model-collections'!

!A4BPCollection commentStamp: '<historical>' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!A4BPCollection methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/11/2015 15:54'!
addAll: anCollection
	^ collection addAll: anCollection! !

!A4BPCollection methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/13/2015 10:11'!
at: key put: aPath
	^ collection add: aPath! !

!A4BPCollection methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 16:22'!
collection
	collection ifNil:[ collection := OrderedCollection new].
	^ collection ! !

!A4BPCollection methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 16:48'!
first
	^ collection first! !

!A4BPCollection methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/11/2015 15:54'!
initialize
	super initialize.
	collection := OrderedCollection new.! !

!A4BPCollection methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/25/2015 14:57'!
values
	^ collection! !

A4BPAbstractCollection subclass: #A4BPDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model-collections'!

!A4BPDictionary commentStamp: '<historical>' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!A4BPDictionary methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 4/13/2015 08:11'!
at: anKey
	^ collection at: anKey! !

!A4BPDictionary methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/13/2015 17:58'!
at: index ifAbsent: aBlock
	^ collection at: index ifAbsent: aBlock! !

!A4BPDictionary methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:15'!
at: index put: value 
	^ collection at: index put: value! !

!A4BPDictionary methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 16:23'!
collection
	collection ifNil:[ collection := Dictionary new].
	^ collection! !

!A4BPDictionary methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:15'!
dictionary
	^ collection! !

!A4BPDictionary methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:15'!
dictionary: anObject
	collection := anObject! !

!A4BPDictionary methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:15'!
elementAt: key
	^ collection elementAt: key! !

!A4BPDictionary methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:15'!
initialize
	super initialize.
	collection := Dictionary new.! !

!A4BPDictionary methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamo 4/11/2015 17:15'!
remove: aObj
	collection removeKey: aObj key ifAbsent: [].! !

!A4BPDictionary methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/14/2015 12:55'!
removeKey: key ifAbsent: aBlock
	^ collection removeKey: key ifAbsent: aBlock! !

A4BPAbstractCollection subclass: #A4BPSortedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model-collections'!

!A4BPSortedCollection methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 16:24'!
collection
	collection ifNil:[ collection := SortedCollection new].
	^ collection! !

!A4BPSortedCollection methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/13/2015 18:25'!
initialize
	super initialize.
	collection := SortedCollection new! !

Object subclass: #A4BPAbstractParser
	instanceVariableNames: 'lstElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

!A4BPAbstractParser class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:07'!
fromXMLDescription: xmlDescription 
	^ self new! !

!A4BPAbstractParser class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
parseString: string
	^ self new parseString: string! !

!A4BPAbstractParser class methodsFor: 'definition' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 21:57'!
xsd
	^ ''! !

!A4BPAbstractParser class methodsFor: 'definition' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 21:56'!
xsdStream
	^ ReadStream on: self xsd! !

!A4BPAbstractParser methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
addElement: aElement
	lstElements add: aElement! !

!A4BPAbstractParser methodsFor: 'add' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 10:17'!
addInContext: context
	context addAllElements: self elements.! !

!A4BPAbstractParser methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:57'!
elements
	^ self lstElements! !

!A4BPAbstractParser methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 1/10/2016 22:58'!
filePrefix
	^ OrderedCollection new.! !

!A4BPAbstractParser methodsFor: 'abstract' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:41'!
getBaseElement
	^ A4BPEmptyObj ! !

!A4BPAbstractParser methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:51'!
getDocumentBaseOnStream: aStream
	"return the object to be parser"
	| document |
	document := A4BPFactoryXMLParser parser parse: aStream.
	^ document! !

!A4BPAbstractParser methodsFor: 'abstract' stamp: 'AlvaroJosePeraltaOcampo 3/13/2015 23:54'!
getTagRef
	^ A4BPParserTagsXMLRef! !

!A4BPAbstractParser methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
initialize
	super initialize.
	lstElements := OrderedCollection new! !

!A4BPAbstractParser methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
lstElements
	^ lstElements! !

!A4BPAbstractParser methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 23:25'!
manageError: e inFile: aFile 
	|element|
	A4BPLog f: 'Error Parsing file' , aFile fullPath asString , 'ERROR:' , e asString.
	element := A4BPUnParserObj new.
	element fileName: aFile fullPath basename.
	element tagName: element fileName.
	element fullPath: aFile fullName.
	element error: e.
	self addElement: element.
! !

!A4BPAbstractParser methodsFor: 'metric' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
numberOfElements
	^ self lstElements size.! !

!A4BPAbstractParser methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 1/10/2016 23:14'!
parseFile: aFile
	"base on stream object the stream create BPObjets to represent the xml in memory"
	
	[ ^ self parseFileWithError: aFile ]
		on: Error
		do: [ :e |  
			
			self manageError: e inFile: aFile ]
	
	"^ self parseFileWithError: aFile "! !

!A4BPAbstractParser methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcamop 5/25/2015 15:21'!
parseFileWithError: aFile
	"base on stream object the stream create BPObjets to represent the xml in memory"
	"('PRGestionBOBTTR.bpmn' = aFile fullPath basename) ifTrue:[self halt]."
	aFile
		readStreamDo: [ :stream | 
			| document |
			"Start creating a XMLDOM Object from stream"
			document := self getDocumentBaseOnStream: stream.
			document nodes
				do: [ :docAtr | 
					| bpElement refTag |
					refTag := self getTagRef getClassBPBaseOnTypeName: docAtr localName.
					bpElement := refTag objclass fromXMLDescription: docAtr.
					bpElement fileName: aFile fullPath basename.
					bpElement fullPath: aFile fullName.
					bpElement buildInternalRelations.
					A4BPLog f: ' new element was create,name:' , bpElement fileName.
					self addElement: bpElement ] ]! !

!A4BPAbstractParser methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 19:41'!
parseStream: stream
	"base on stream object the stream create BPObjets to represent the xml in memory"
	| document |
	"Start creating a XMLDOM Object from stream"
	"document := (XMLDOMParser on: stream) parseDocument."
	document := self getDocumentBaseOnStream: stream.
	document nodes do: [ :docAtr | 
			| bpElement refTag localName|
			localName := docAtr localName.
			refTag := self getTagRef getClassBPBaseOnTypeName: localName.
			bpElement := refTag objclass fromXMLDescription: docAtr.
			bpElement buildInternalRelations.
			self addElement: bpElement ]! !

!A4BPAbstractParser methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
parseString: string
	^ self parseStream:  (ReadStream on: string)! !

Object subclass: #A4BPAbstractVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-visitor'!

!A4BPAbstractVisitor commentStamp: '<historical>' prior: 0!
An A4BPAbstractVisitor is basic class to help to avoid visitor who not need all visitor implementation.
!

!A4BPAbstractVisitor methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
initialize
	"comment stating purpose of message"

	super initialize.! !

!A4BPAbstractVisitor methodsFor: 'visitor-A4BP' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 09:52'!
visitA4BPEmptyObj: aModel
	^ self visitA4BPObject: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-A4BP' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 09:50'!
visitA4BPObject: aModel
	"do nothing"! !

!A4BPAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 12/9/2014 09:40'!
visitA4BPSOAContext: aModel
	^ 0! !

!A4BPAbstractVisitor methodsFor: 'visitor-A4BP' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 09:52'!
visitA4BPUnParserObj: aModel
	^ self visitA4BPObject: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBBPWait: aBPWait
	^ self visitBPObject: aBPWait ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPActivity: aBPActivity
	^ self visitBPObject: aBPActivity ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPActivityBasic: aBPActivityBasic
	^ self visitBPObject: aBPActivityBasic ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPActivityComposite: aBPActivityComposite
	^ self visitBPObject: aBPActivityComposite ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPAssign: aBPAssign
	^ self visitBPObject: aBPAssign ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPBPELObject: aModel
	^ self visitBPObject: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPCatch: aBPCatch
	^ self visitBPObject: aBPCatch ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPCatchAll: aBPCatchAll
		^ self visitBPObject: aBPCatchAll ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPCopy: aBPCopy
	^ self visitBPObject: aBPCopy ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPElseIf: aBPElseIf
	^ self visitBPObject: aBPElseIf ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPEmpty: aBPEmpty
	^ self visitBPObject: aBPEmpty ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPExit: aBPExit
	^ self visitBPObject: 	aBPExit ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPExtensionActitity: aBPExtensionActitity
	^ self visitBPObject: aBPExtensionActitity ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPFaultHandlers: aBPFaultHandlers
	^ self visitBPObject: aBPFaultHandlers ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPFlow: aBPFlow
	^ self visitBPObject: aBPFlow ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPFor: aBPFor
	^ self visitBPObject: aBPFor! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPForEach: aBPForEach
	^ self visitBPObject: aBPForEach ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPForUntilGroup: aBPForUntilGroup
	^ self visitBPObject: aBPForUntilGroup! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPFrom: aBPFrom
	^ self visitBPObject: aBPFrom! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPIf: aBPIf
	^ self visitBPObject: aBPIf ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPInvoke: aBPInvoke
	^ self visitBPObject: 	aBPInvoke ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ActivityImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20AdHocSubProcessImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ArtifactImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20AssignmentImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20AssociationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20AuditingImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20BPMNDiagramImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20BPMNEdgeImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20BPMNLabelImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20BPMNLabelStyleImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20BPMNPlaneImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20BPMNShapeImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20BaseElementImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20BoundaryEventImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/14/2015 22:13'!
visitBPMN20BoundsImpl: aModel
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20Bpmn2FactoryImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20Bpmn2PackageImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20BpmnDiFactoryImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20BpmnDiPackageImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20BusinessRuleTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20CallActivityImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20CallChoreographyImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20CallConversationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20CallableElementImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20CancelEventDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20CatchEventImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20CategoryImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20CategoryValueImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ChoreographyActivityImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ChoreographyImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ChoreographyTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20CollaborationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20CompensateEventDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ComplexBehaviorDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ComplexGatewayImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ConditionalEventDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ConversationAssociationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ConversationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ConversationLinkImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ConversationNodeImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20CorrelationKeyImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20CorrelationPropertyBindingImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20CorrelationPropertyImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20CorrelationPropertyRetrievalExpressionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20CorrelationSubscriptionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DataAssociationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DataInputAssociationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DataInputImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DataObjectImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DataObjectReferenceImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DataOutputAssociationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DataOutputImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DataStateImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20DataStoreImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DataStoreReferenceImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 15:51'!
visitBPMN20DefinitionsImpl: aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DiFactoryImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DiPackageImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DiagramElementImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DiagramImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DocumentRootImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20DocumentationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20EdgeImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20EndEventImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20EndPointImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ErrorEventDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ErrorImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20EscalationEventDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20EscalationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20EventBasedGatewayImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20EventDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20EventImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ExclusiveGatewayImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ExpressionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ExtensionAttributeDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ExtensionAttributeValueImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ExtensionDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ExtensionElementsImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ExtensionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20FlowElementImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20FlowElementsContainerImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20FlowNodeImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 6/12/2015 01:08'!
visitBPMN20FlowNodeRefImpl: aModel
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20FormalExpressionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20GatewayImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20GlobalBusinessRuleTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20GlobalChoreographyTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20GlobalConversationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20GlobalManualTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20GlobalScriptTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20GlobalTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20GlobalUserTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20GroupImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20HumanPerformerImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ImplicitThrowEventImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ImportImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20InclusiveGatewayImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20IncomingImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20InputOutputBindingImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20InputOutputSpecificationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20InputSetImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20InteractionNodeImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20InterfaceImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20IntermediateCatchEventImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20IntermediateThrowEventImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ItemAwareElementImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ItemDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20LabelImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20LabeledEdgeImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20LabeledShapeImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20LaneImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20LaneSetImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20LinkEventDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20LoopCharacteristicsImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ManualTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 14:28'!
visitBPMN20MessageEventDefinitionImpl: aModel
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20MessageFlowAssociationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20MessageFlowImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20MessageImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20MonitoringImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20MultiInstanceLoopCharacteristicsImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20NodeImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/6/2015 18:20'!
visitBPMN20Object: aModel
	^ self visitBPObject: aModel ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20OperationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20OutgoingImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20OutputSetImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 6/12/2015 11:17'!
visitBPMN20ParallelGatewayImpl: aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ParticipantAssociationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ParticipantImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ParticipantMultiplicityImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20PartnerEntityImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20PartnerRoleImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20PerformerImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20PlaneImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20PotentialOwnerImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcamop 5/21/2015 01:40'!
visitBPMN20ProcessImpl: aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20PropertyImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ReceiveTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20RefToBeBuild:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20RelationshipImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20RenderingImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ResourceAssignmentExpressionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ResourceImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ResourceParameterBindingImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ResourceParameterImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20ResourceRoleImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20RootElementImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ScriptTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20SendTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20SequenceFlowImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ServiceTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ShapeImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20SignalEventDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20SignalImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20SourceRefImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20StandardLoopCharacteristicsImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20StartEventImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20StyleImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20SubChoreographyImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20SubConversationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20SubProcessImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20TargetRefImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20TaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20TerminateEventDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:45'!
visitBPMN20TextAnnotationImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20ThrowEventImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20TimerEventDefinitionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20TransactionImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:46'!
visitBPMN20UserTaskImpl:aModel 
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPMN20' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 09:40'!
visitBPNM20ExtensionImpl: aModel
	^ self visitBPMN20Object: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPObject: aBPObject
	^ 0! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPOnAlarmEvent: aBPOnAlarmEvent
	^ self visitBPObject: aBPOnAlarmEvent! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPOnEvent: aBPOnEvent
	^ self visitBPObject: aBPOnEvent! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPOnMessage: aBPOnMessage
	^ self visitBPObject: aBPOnMessage! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPOnMsgCommon: aBPOnMsgCommon
	^ self visitBPObject: aBPOnMsgCommon! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPPartnerLink: aBPPartnerLink
	^ self visitBPObject: 	aBPPartnerLink ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPPartnerLinks: aBPPartnerLinks
	^ self visitBPObject: aBPPartnerLinks ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPPick: aBPPick
	^ self visitBPObject: aBPPick ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPProcess: aBPProcess
	^ self visitBPObject: aBPProcess ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPReceive: aBPReceive
	^ self visitBPObject: aBPReceive ! !

!A4BPAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPRel: aVisitor
		^ self visitBPObject: aVisitor ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPRepeatEvery: aBPRepeatEvery
	^ self visitBPObject: aBPRepeatEvery! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPRepeatUntil: aBPRepeatUntil
	^ self visitBPObject: aBPRepeatUntil ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPReply: aBPReply
	^ self visitBPObject: aBPReply ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPRethrow: aBPRethrow
	^ self visitBPObject: aBPRethrow ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPScope: aBPScope
	^ self visitBPObject: aBPScope ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPSequence: aBPSequence
	^ self visitBPObject: aBPSequence ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPSwitch: aBPSwitch
	^ self visitBPObject: aBPSwitch ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPThrow: aBPThrow
	^ self visitBPObject: aBPThrow ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPTo: aBPTo
	^ self visitBPObject: aBPTo! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPUntil: aBPUntil
	^ self visitBPObject: aBPUntil! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPValidate: aBPValidate
	^ self visitBPObject: aBPValidate ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPVariable: aBPVariable
	^ self visitBPObject: aBPVariable ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPVariables: aBPVariables
	^ self visitBPObject: 	aBPVariables ! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLBinding: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLDefinition: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLDocumentation: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLElement: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLImport: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLInclude:  aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLMessage:  aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLObject: aModel
	^ self visitBPObject: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLOperation:  aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLPart: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLPlnkRole: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLPlnkType: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLPort: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLPortType:aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLSchema: aModel
	^ self visitBPObject: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLService: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLTypes: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-WSDL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWSDLwsdl: aBPWSDLwsdl
	^ self visitBPObject: 	aBPWSDLwsdl ! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL-Activity' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPWhile: aBPWhile
	^ self visitBPObject: aBPWhile ! !

!A4BPAbstractVisitor methodsFor: 'visitor-XSD' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPXSDComplexType: aModel
	^ self visitBPObject: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-XSD' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPXSDElement: aModel
	^ self visitBPObject: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-XSD' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPXSDImport: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-XSD' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPXSDInclude: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-XSD' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPXSDObject: aModel
	^ self visitBPObject: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-XSD' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPXSDSchema: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-XSD' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPXSDSequence: aObj
	^ self visitBPObject: aObj! !

!A4BPAbstractVisitor methodsFor: 'visitor-XSD' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitBPXSDSimpleType: aModel
	^ self visitBPObject: aModel! !

!A4BPAbstractVisitor methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 18:04'!
visitSOAAnalyzer: aSOAAnalyzer
	^ self visitBPObject: aSOAAnalyzer ! !

A4BPAbstractVisitor subclass: #A4BPMetricAbsCFC
	instanceVariableNames: 'cfcMetric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-metric'!

!A4BPMetricAbsCFC commentStamp: 'AlvaroJosePeraltaOcampo 4/1/2015 10:20' prior: 0!
An A4BPMetricAbsCFC is visitor class to calculo
the absolute value into a process stage.
Notes: 
(cardoros 2008)
Control-Flow complexity of business ProcessesMathematically, control-flow complexity metric is additive. 
	Thus, it is very easy to calculate the complexity of a process simply by adding the CFC of all split constructs. 
	The absolute con- trol-flow complexity is calculated as follows, where P is a business process.
	CFC (P) = abs
	( ∑ CFCXOR−split i) + i∈(XOR-splits of P)
	( ∑ CFCOR−split j)+ j∈(OR-splits of P)
	( ∑ CFCAND−split k)+ k∈(AND-splits of P)
	The relative control-flow complexity for process P is calculated as follows, where |P| is the number of activities of process P 	(see Box 1).
	The greater the value of the CFCabs(P) and CFCrel(P), the greater the overall architectural complexity of a process. CFC 	analysis seeks to evaluate complexity without direct execution of processes. 
	The function of CFC is computed based on the 	individual control-flow complex- ity of XOR, OR, and AND –splits. 
	Unless 	otherwise stated, CFC(P) denotes the absolute 	control-flow complexity.
	"!

!A4BPMetricAbsCFC class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:20'!
annotation
<MSEClass: #A4BPMetricAbsCFC  super: #A4BPAbstractVisitor >
<package: #'A4BP-BPMN20-core' >! !

!A4BPMetricAbsCFC methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 10:30'!
calculeCFC: aModel
	^ aModel accept: self! !

!A4BPMetricAbsCFC methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 10:49'!
calculeInGateways: aModel
	"
	CFC (P) = abs
	( ∑ CFCXOR−split i) + i∈(XOR-splits of P)
	( ∑ CFCOR−split j)+ j∈(OR-splits of P)
	( ∑ CFCAND−split k)+ k∈(AND-splits of P)
	"
	| cfc |
	cfc := cfcMetric calculeCFC: aModel.
	aModel outgoing do: [ :el | cfc := cfc + (el accept: self) ].
	^ cfc! !

!A4BPMetricAbsCFC methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 17:30'!
initialize
	super initialize.
	cfcMetric := A4BPMetricCFC new.! !

A4BPAbstractVisitor subclass: #A4BPMetricCFC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-metric'!

!A4BPMetricCFC commentStamp: '<historical>' prior: 0!
An A4BPMetricCFC is xxxxxxxxx.
!

!A4BPMetricCFC class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:20'!
annotation
<MSEClass: #A4BPMetricCFC  super: #A4BPAbstractVisitor >
<package: #'A4BP-BPMN20-core' >! !

!A4BPMetricCFC methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 10:30'!
calculeCFC: aModel
	^ aModel accept: self! !

!A4BPMetricCFC methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 00:13'!
metricCFC: aModel
	^ aModel accept: self! !

Object subclass: #A4BPAbstractXML
	instanceVariableNames: 'parser writer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

!A4BPAbstractXML commentStamp: '<historical>' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	parser:		<Object>
	writer:		<Object>


    Implementation Points!

!A4BPAbstractXML class methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
createBaseOn: aParser
	| obj |
	obj := self new.
	obj parser: aParser.
	^ obj! !

!A4BPAbstractXML methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
allElementsNamed: key! !

!A4BPAbstractXML methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
insertAfter: aXML
	! !

!A4BPAbstractXML methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
insertBefore: aXML
! !

!A4BPAbstractXML methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
nameSpaces! !

!A4BPAbstractXML methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
nodes! !

!A4BPAbstractXML methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
parse: aStream! !

!A4BPAbstractXML methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
parser
	^ parser! !

!A4BPAbstractXML methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
parser: aParser
	^ parser := aParser! !

!A4BPAbstractXML methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
xPath
	^ self xpath! !

!A4BPAbstractXML methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
xpath
	"return a string with the path of the node"
	^ '','/', parser name. ! !

A4BPAbstractXML subclass: #A4BPXMLParserPeti
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

!A4BPXMLParserPeti commentStamp: '<historical>' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!A4BPXMLParserPeti class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:26'!
annotation
<MSEClass: #A4BPXMLParserPeti  super: #A4BPAbstractXML >
<package: #'A4BP-core' >! !

!A4BPXMLParserPeti methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:48'!
allElementsNamed: key
	| col returnCol |
	returnCol := OrderedCollection new.
	col := parser findXPath: key.
	col children do: [ :n | returnCol add: (A4BPXMLParserPeti createBaseOn: n) ].
	^ returnCol! !

!A4BPXMLParserPeti methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
attributeAt: aAtribute
	^ parser attributes collect:[ :a | a = aAtribute ].! !

!A4BPXMLParserPeti methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
name
	^ parser name! !

!A4BPXMLParserPeti methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
nameSpaces
	"^ node namespaceScope prefixMappings dictionary"
	^ OrderedCollection new.! !

!A4BPXMLParserPeti methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
nodes
	| col returnCol |
	returnCol := OrderedCollection new.
	col := parser childNodes.
	col do: [ :n | returnCol add: (BPXMLParserPeti createBaseOn: n) ].
	^ returnCol! !

!A4BPXMLParserPeti methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:44'!
parse: aStream
	|document bpNode|
	document := PPXmlParser new end parse:aStream.
	bpNode := A4BPXMLParserPeti createBaseOn: document.
	^ bpNode! !

A4BPAbstractXML subclass: #A4BPXMLParserXMLDOM
	instanceVariableNames: 'tagWriter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

A4BPXMLParserXMLDOM class
	instanceVariableNames: 'node'!

!A4BPXMLParserXMLDOM commentStamp: '<historical>' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	tagWriter:		<Object>


    Implementation Points!

A4BPXMLParserXMLDOM class
	instanceVariableNames: 'node'!

!A4BPXMLParserXMLDOM class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:26'!
annotation
<MSEClass: #A4BPXMLParserXMLDOM  super: #A4BPAbstractXML >
<package: #'A4BP-core' >! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:44'!
allElementsNamed: key
	|col returnCol|
	returnCol := OrderedCollection new.
	col:= parser allElementsNamed: key.
	col do:[ :n| returnCol add: (A4BPXMLParserXMLDOM createBaseOn:n) ].
	^ returnCol.! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 4/15/2015 08:53'!
asString
	^ parser fullPrintString! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
attributeAt: aAtribute
	^ parser attributeAt: aAtribute! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
contentString
 ^ parser contentString.! !

!A4BPXMLParserXMLDOM methodsFor: 'finder' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 16:48'!
getRefName: anName
	| type |
	[ 
	| element |
	element := parser
		allElementsDetect: [ :n | 
			| e |
			e := nil.
			[ e := n attributeAt: 'name' ]
				on: Error
				do: [  ].
			e = anName ].
	type := element attributeAt: 'ref' ]
		on: Error
		do: [ type := anName ].
	type = ''
		ifTrue: [ type := anName ].
	^ type! !

!A4BPXMLParserXMLDOM methodsFor: 'finder' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 16:05'!
getSubstitutionGroupName: anName
	| type |
	[ type := (parser allElementsDetect: [ :n | (n attributeAt: 'name') = anName ]) attributeAt: 'substitutionGroup' ]
		on: Error
		do: [ type := anName ].
	'' = type ifTrue:[type := anName].
	^ type! !

!A4BPXMLParserXMLDOM methodsFor: 'finder' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 16:05'!
getTypeName: anName
	| type |
	[ type := (parser allElementsDetect: [ :n | (n attributeAt: 'name') = anName ]) attributeAt: 'type' ]
		on: Error
		do: [ type := anName ].
	'' = type ifTrue:[type := anName].
	^ type! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
initWriter
	writer := XMLWriter new.! !

!A4BPXMLParserXMLDOM methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:43'!
initialize
	super initialize.
	writer := XMLWriter new.! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:44'!
insertAfter: aXML
	|aNewDoc |
	aNewDoc := A4BPFactoryXMLParser parser parse: (ReadStream on: aXML).
	parser writeXMLWithOutChildrenOn: writer.
	aNewDoc parser writeXMLOn: writer.
	^ writer! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:44'!
insertAfter: aXML on:aParser
	|aNewDoc |
	aNewDoc := A4BPFactoryXMLParser parser parse: (ReadStream on: aXML).
	parser writeXMLWithOutChildrenOn: writer.
	aNewDoc parser writeXMLOn: writer.
	^ writer! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:44'!
insertBefore: aXML
	|aNewDoc |
	aNewDoc := A4BPFactoryXMLParser parser parse: (ReadStream on: aXML).
	aNewDoc parser writeXMLOn: writer.	
	parser writeXMLWithOutChildrenOn: writer.
	^ writer! !

!A4BPXMLParserXMLDOM methodsFor: 'testing' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 12:25'!
isStringValue
	^ parser class = XMLString! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 3/13/2015 20:47'!
localName
	^ parser localName! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
name
	^ parser name! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
nameSpaces
	^ parser namespaceScope prefixMappings dictionary! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:44'!
nodes
	|col returnCol|
	returnCol := OrderedCollection new.
	col:= parser nodes.
	col do:[ :n| returnCol add: (A4BPXMLParserXMLDOM createBaseOn:n) ].
	^ returnCol.! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:44'!
parse: aStream
	| document bpNode |
	document := (XMLDOMParser on: aStream) parseDocument.
	bpNode := A4BPXMLParserXMLDOM createBaseOn: document.
	^ bpNode! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
startWriter
	writer := XMLWriter new.
	self writeXMLOn: writer.! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 12:34'!
string
	^ parser string! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
tag: aName
	^ writer tag:aName! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
writeChildren: aBlock
	"use the sentence on XMLElement to execute similarity"
	tagWriter with: aBlock.! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
writeOn: aWriter
	parser writeXMLOn: aWriter.
	^ aWriter! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
writeWithOutChildrenOn: aWriter
	tagWriter:= parser writeXMLWithOutChildrenOn: aWriter.
	^ tagWriter! !

!A4BPXMLParserXMLDOM methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
writeXMLOn: aWriter
	parser writeXMLOn: aWriter.
	^ aWriter! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
xpath
	"return a string with the path of the node"
	^ (self xpathOf: parser parent),'/',parser name.! !

!A4BPXMLParserXMLDOM methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:42'!
xpathOf: aDoc
	aDoc parent ifNil: [ ^ '' ].
	^ (self xpathOf: aDoc parent) , '/' , aDoc name! !

Object subclass: #A4BPBaseMetric
	instanceVariableNames: 'aName algorithm derivation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-metric'!

!A4BPBaseMetric methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/30/2015 18:57'!
aName
	^ aName! !

!A4BPBaseMetric methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/30/2015 18:57'!
aName: anObject
	aName := anObject! !

!A4BPBaseMetric methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/30/2015 18:57'!
algorithm
	^ algorithm! !

!A4BPBaseMetric methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/30/2015 18:57'!
algorithm: anObject
	algorithm := anObject! !

!A4BPBaseMetric methodsFor: 'calculate' stamp: 'AlvaroJosePeraltaOcamop 5/30/2015 19:22'!
calculate
	^ 0! !

!A4BPBaseMetric methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/30/2015 18:57'!
derivation
	^ derivation! !

!A4BPBaseMetric methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/30/2015 18:57'!
derivation: anObject
	derivation := anObject! !

A4BPBaseMetric subclass: #A4BPCohesionMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-metric'!

A4BPBaseMetric subclass: #A4BPComplexityMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-metric'!

A4BPBaseMetric subclass: #A4BPCouplingMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-metric'!

Object subclass: #A4BPDimension
	instanceVariableNames: 'aName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-metric'!

!A4BPDimension methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/30/2015 18:58'!
aName
	^ aName! !

!A4BPDimension methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/30/2015 18:58'!
aName: anObject
	aName := anObject! !

Object subclass: #A4BPFactoryXMLParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

!A4BPFactoryXMLParser commentStamp: '<historical>' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!A4BPFactoryXMLParser class methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 12:43'!
parser
	^ A4BPXMLParserXMLDOM new.
	"^ BPXMLParserPetiXMLParser new."! !

Object subclass: #A4BPLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-log'!

!A4BPLog class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:25'!
annotation
<MSEClass: #A4BPLog  super: #Object >
<package: #'A4BP-core' >! !

!A4BPLog class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 21:29'!
d: astring
	Transcript
		show: astring;
		cr! !

!A4BPLog class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 21:29'!
e: astring
	Transcript
		show: astring;
		cr! !

!A4BPLog class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 21:29'!
f: astring
	Transcript
		show: astring;
		cr! !

!A4BPLog class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 21:29'!
l: astring
	Transcript
		show: astring;
		cr! !

!A4BPLog class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 21:29'!
w: astring
	Transcript
		show: astring;
		cr! !

Object subclass: #A4BPObject
	instanceVariableNames: 'aName parent childrens text myDocument id localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model'!

A4BPObject subclass: #A4BPElementGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model'!

!A4BPElementGroup methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamop 5/25/2015 14:56'!
addElement: aElement
	childrens add: aElement! !

!A4BPElementGroup methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcamop 5/25/2015 14:56'!
addElements: aCollection
	childrens addAll: aCollection! !

!A4BPElementGroup methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcamop 5/25/2015 14:56'!
initialize
	aName := ''.
	childrens := A4BPCollection new.! !

A4BPObject subclass: #A4BPEmptyObj
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model'!

A4BPEmptyObj class
	instanceVariableNames: 'instance'!

A4BPEmptyObj class
	instanceVariableNames: 'instance'!

!A4BPEmptyObj class methodsFor: 'instance' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:19'!
annotation
<MSEClass: #A4BPEmptyObj  super: #A4BPObject >
<package: #'A4BP-core' >! !

!A4BPEmptyObj class methodsFor: 'instance' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 18:32'!
instance
	instance ifNil:[instance:=self basicNew].
	instance aName:'A4BPEmptyObj'.
	^ instance! !

!A4BPEmptyObj class methodsFor: 'instance' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 18:31'!
new
	A4BPLog w:'A4BP warning:Do you use new message to get A4BPEmptyObj, please use better instance message'.
	^ self instance! !

!A4BPEmptyObj methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 09:32'!
accept: aVisitor
	^ aVisitor visitA4BPEmptyObj: self! !

!A4BPEmptyObj methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
allElements
	^ OrderedCollection new! !

!A4BPEmptyObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
bpwsdl
	^ nil! !

!A4BPEmptyObj methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 08:48'!
equals: aModel
	^ aModel = self! !

!A4BPEmptyObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
getChildrenNodes
	^ nil! !

!A4BPEmptyObj methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
initialize
	super initialize.
	aName:='Empty'.! !

!A4BPEmptyObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/6/2015 12:40'!
isEmptyObj
 ^ true! !

!A4BPEmptyObj methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
link
	^ self! !

!A4BPObject class methodsFor: 'meta' stamp: 'AlvaroJosePeraltaOcampo 12/10/2014 17:46'!
annotation
	<abstract>
	<MSEClass: #A4BPObject super: #MooseEntity>
	<package: #A4BP>! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 14:38'!
fillBData: document in: aBPObject
	aBPObject myDocument: document.
	aBPObject aName: (self readName: document).
	aBPObject id: (self readId: document).
	aBPObject id = '' ifTrue: [ aBPObject id: UUID new asString ].
	aBPObject text: document asString.
	^ aBPObject! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 15:08'!
fillBDataUsingReflection: document in: obj
	obj localName: document localName.
	self
		instanceVariableNamesDo: [ :v | 
			| value |
			value := self readStringOrEmpty: document at: v asString.
			value = '' ifFalse: [ 				
				obj setUsingRelefection: v obj: value ] ].
	^ obj ! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
fillElementsIn: aBPObj from: document
	^ aBPObj ! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 11/30/2014 19:01'!
fillElementsIn: aBPObject from: document visitor: visitor
	self
		fillElementsIn: aBPObject
		from: document
		visitor: visitor
		tagRef: A4BPParserTagsXMLRef! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 16:52'!
fillElementsIn: obj from: document visitor: visitor tagRef: aTagRef
	document nodes do: [ :n | 
		n isStringValue
		ifTrue: [ obj value: n string ];
		ifFalse: [ 
			|refTag bpElement localName|
			localName := n localName.
			"localName = 'userTask' ifTrue:[self halt.]."
			refTag := aTagRef getClassBPBaseOnTypeName: localName.
			bpElement := refTag objclass fromXMLDescription: n in: obj.
			bpElement accept: visitor 
		]
	]! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 22:43'!
fillElementsIn: obj from: document withMeta: metaDocument
	self
		fillElementsIn: obj
		from: document
		withMeta: metaDocument
		tagRef: A4BPParserTagsXMLRef! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 22:42'!
fillElementsIn: obj from: document withMeta: metaDocument  tagRef: aTagRef
	document nodes
		do: [ :n | 
			n isStringValue
				ifTrue: [ obj value: n string ];
				ifFalse: [ 
						| nName nType refTag bpElement |
						nName := n localName.
						nType := metaDocument getTypeName: nName.
						refTag := aTagRef getClassBPBaseOnTypeName: nType.
						bpElement := refTag objclass fromXMLDescription: n withMeta: metaDocument.
						obj setUsingRelefection: nName obj: bpElement.
						obj setUsingRelefection: nName obj: bpElement withMeta: metaDocument
						] ].
	^ obj! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
fromXMLDescription: document
	| obj |
	obj := self new.
	self fillBData: document in: obj.
	self fillElementsIn: obj from: document.
	^ obj! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 10:51'!
fromXMLDescription: document in: parent
	| aBPObj |
	aBPObj := self new.
	self fillBData: document in: aBPObj.
	aBPObj parent: parent.
	self fillElementsIn: aBPObj from: document.
	^ aBPObj! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 13:30'!
fromXMLDescription: document withMeta: metaDocument
	| obj |
	obj := self new.
	self fillBData: document in: obj.
	self fillBDataUsingReflection: document in: obj.
	self fillElementsIn: obj from: document withMeta: metaDocument.
	^ obj! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/26/2014 05:43'!
readBoolean: document at: tag
	^ [ (document attributeAt: tag) = 'true']
		on: MessageNotUnderstood
		do: [ ^ false ]! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 3/5/2015 18:34'!
readContentString: document
	^ [ document contentString ]
		on: MessageNotUnderstood
		do: [ ^ document asString ]! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 3/14/2015 01:52'!
readId: document
	^ [ document attributeAt: 'id' ]
		on: MessageNotUnderstood
		do: [ ^ document asString ]! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:02'!
readInt: document at: tag
	^ [ (document attributeAt: tag) asInteger ]
		on: MessageNotUnderstood
		do: [ ^ 0 ]! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 22:36'!
readName: document
	^ [ document attributeAt: 'name' ]
		on: MessageNotUnderstood
		do: [ ^ document asString ]! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 13:37'!
readString: document at: tag
	^ [ document attributeAt: tag ]
		on: Error
		do: [ ^ document asString ]! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 13:47'!
readStringOrEmpty: document at: tag
	^ [ document attributeAt: tag ]
		on: Error
		do: [ ^ '' ]! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
aName
	^ aName! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
aName: pname
	aName := pname! !

!A4BPObject methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 12:05'!
accept: aVisitor
	^ aVisitor visitA4BPObject: self! !

!A4BPObject methodsFor: 'doNothing' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
addActivity: aBPActivity! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
addChildren: aModel
	self childrens add:aModel.! !

!A4BPObject methodsFor: 'doNothing' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
addRelation: aRel! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 23:53'!
allChildrenNodes
	^ self allChildrens! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 12:43'!
allChildrens
	|lst|
	lst:=OrderedCollection new.
	lst addAll:self childrens.
	self childrens do:[ :e| lst addAll: e allNodes ].
	^ lst.! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 2/17/2016 11:26'!
allNodes
	^ self allChildrens! !

!A4BPObject methodsFor: 'doNothing' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
allRelations
	^ OrderedCollection new! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
asString
	"
	^ aName , '[', self hash asString,'],',super asString.
	"
	^ self aName! !

!A4BPObject methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 3/6/2015 08:17'!
buildInternalRelations
	" Use to make relations with self,probably use after the parser process done "

	! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 23:51'!
childrenNodes
	^ self childrens values! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
childrens
	"leazy initialization"
	^ childrens ifNil:[childrens:=OrderedCollection new].! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
childrens: aCollection
	childrens := aCollection! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
cnodes
	^ self childrens ! !

!A4BPObject methodsFor: 'dsl' stamp: 'AlvaroJosePeraltaOcampo 4/5/2016 14:32'!
elements
	^ self allNodes! !

!A4BPObject methodsFor: 'dsl' stamp: 'AlvaroJosePeraltaOcampo 8/31/2015 00:40'!
flowElements
	^ self flows! !

!A4BPObject methodsFor: 'dsl' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 11:06'!
flows
	^ OrderedCollection new! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 11:21'!
getChildrenNodes
	^ self childrens values! !

!A4BPObject methodsFor: 'questions' stamp: 'AlvaroJosePeraltaOcamop 6/5/2015 08:49'!
iHaveRelationWith: aRelation
	^ false! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 09:37'!
id
	id ifNil:[ id := UUID new asString ].
	^ id! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/14/2015 21:27'!
id: anId
	^ id := anId! !

!A4BPObject methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 11:22'!
initialize
	aName := ''.
	childrens := A4BPDictionary new.! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 08:05'!
isAProcess
	^ false! !

!A4BPObject methodsFor: 'questions' stamp: 'AlvaroJosePeraltaOcampo 3/6/2015 12:40'!
isEmptyObj
 ^ false! !

!A4BPObject methodsFor: 'questions' stamp: 'AlvaroJosePeraltaOcampo 3/24/2015 09:57'!
isProcess
	^ false! !

!A4BPObject methodsFor: 'questions' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 09:33'!
isSchema
	^ false! !

!A4BPObject methodsFor: 'questions' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 23:04'!
isUnparseObj
 ^ false! !

!A4BPObject methodsFor: 'questions' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 09:33'!
isWSDL
	^ false! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 14:35'!
key
	^ self id! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
label
	^ self aName! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 15:08'!
localName
	^ localName! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 15:08'!
localName: anLocalName
	^ localName := anLocalName! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 11:02'!
metaModelBaseClass
	^ A4BPObject ! !

!A4BPObject methodsFor: 'metric' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 00:16'!
metricCFC
	^ 0! !

!A4BPObject methodsFor: 'metric' stamp: 'AlvaroJosePeraltaOcamop 6/4/2015 14:03'!
metricCFCAbs
	^ 0! !

!A4BPObject methodsFor: 'moose' stamp: 'AlvaroJosePeraltaOcampo 11/25/2014 19:52'!
mooseNameOn: aStream 
	aStream nextPutAll: self aName! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
myDocument
	^ myDocument! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
myDocument: document
	myDocument := document! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
name
	^ self aName! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 23:00'!
nameSpaces
	^ self myDocument nameSpaces! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
parent
	^ parent! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
parent: aModel
	parent
		ifNil: [ 
			parent := aModel.
			parent addChildren: self ]! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 9/22/2015 12:57'!
process
	^ A4BPCollection new! !

!A4BPObject methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcamop 6/5/2015 09:22'!
relations
	^ A4BPCollection new! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcamo 4/13/2015 00:27'!
setNilParent
	parent := nil! !

!A4BPObject methodsFor: 'reflection' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 15:57'!
setUsingRelefection: var obj: obj
	[ 
	| varName variable value tvariable |
	varName := var first asLowercase asString , (var last: var size - 1).
	variable := self instVarNamed: varName.
	value := obj.
		
	variable ifNil: [ ^ self instVarNamed: varName put: value ].
	
	variable class = Dictionary
		ifTrue: [ ^ variable at: value key put: value ].
		
	tvariable := Dictionary new.
	tvariable at: variable key put: variable.
	tvariable at: value key put: value.
	value := tvariable.
	self instVarNamed: varName put: value ]
		on: Error
		do: [ 
			"do nothing because the model dont support the tag "
			 ]! !

!A4BPObject methodsFor: 'reflection' stamp: 'AlvaroJosePeraltaOcampo 3/16/2015 16:58'!
setUsingRelefection: var obj: obj withMeta: metaDocument
	| subTitutionGroup |
	subTitutionGroup := metaDocument getSubstitutionGroupName: obj localName.
	self class
		instanceVariableNamesDo: [ :v | 
			| ref |
			"(obj localName = 'FloatingParameter' and: v = 'parameterValue') ifTrue:[ self halt ]."
			ref := metaDocument getRefName: v asString.
			subTitutionGroup = ref
				ifTrue: [ self setUsingRelefection: v obj: obj ] ]! !

!A4BPObject methodsFor: 'metric' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
size
	^ 1! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
text
	^ text! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
text: aText
	text := aText! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 5/8/2016 22:19'!
value: aValue
	! !

!A4BPObject methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
xml
	myDocument ifNotNil: [ ^ myDocument parser asString ].
	^ ''! !

A4BPObject subclass: #A4BPSOAAnalyzer
	instanceVariableNames: 'lstSOAContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model'!

A4BPSOAAnalyzer class
	instanceVariableNames: 'instance'!

A4BPSOAAnalyzer class
	instanceVariableNames: 'instance'!

!A4BPSOAAnalyzer class methodsFor: 'moose' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:19'!
annotation
<MSEClass: #A4BPSOAAnalyzer  super: #A4BPObject >
<package: #'A4BP-core' >! !

!A4BPSOAAnalyzer class methodsFor: 'singleton' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
instance
	instance ifNil: [ instance := self new ].
	^ instance! !

!A4BPSOAAnalyzer class methodsFor: 'singleton' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 07:39'!
reset
	"self reset"
	instance := nil.
	^ 'OK'! !

!A4BPSOAAnalyzer methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
accept: aVisitor
	^ aVisitor visitSOAAnalyzer:self.! !

!A4BPSOAAnalyzer methodsFor: 'action' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
addSOAContext: aSOAContext
	lstSOAContext at: aSOAContext key put: aSOAContext! !

!A4BPSOAAnalyzer methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 16:19'!
contexts
	^ self lstSOAContext  ! !

!A4BPSOAAnalyzer methodsFor: 'action' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
deleteSOAContext: aSOAContext
	lstSOAContext removeKey: aSOAContext key.! !

!A4BPSOAAnalyzer methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
getChildrenNodes
	^ self lstSOAContext ! !

!A4BPSOAAnalyzer methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
initialize
	super initialize.
	aName:='SOAAnalyzer'.
	lstSOAContext := Dictionary new! !

!A4BPSOAAnalyzer methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 12/10/2014 23:42'!
lstSOAContext
	^ lstSOAContext! !

!A4BPSOAAnalyzer methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 09:00'!
lstSOAContext: alstSOAContext
	^ lstSOAContext := alstSOAContext! !

!A4BPSOAAnalyzer methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
soaContexts
	^ self lstSOAContext  ! !

A4BPObject subclass: #A4BPSOAContext
	instanceVariableNames: 'lstElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model'!

!A4BPSOAContext class methodsFor: 'moose' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:19'!
annotation
<MSEClass: #A4BPSOAContext  super: #A4BPObject >
<package: #'A4BP-core' >! !

!A4BPSOAContext class methodsFor: 'create' stamp: 'AlvaroJosePeraltaOcamop 6/5/2015 08:46'!
createBaseOnPath: aPath
	| context |
	context := self new.
	context createBaseOnPath: aPath.
	"for each context like BPEL20 or BPMN20 do the same proces in the base class"
	A4BPSOAContext subclassesDo: [ :soacClass | 
			| soacInstance |
			soacInstance := soacClass new.
			soacInstance createBaseOnPath: aPath.
			context joinContext: soacInstance ].
	context buildRelations.
	^ context! !

!A4BPSOAContext methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/26/2014 15:18'!
accept: aVisitor
	^ aVisitor visitA4BPSOAContext: self! !

!A4BPSOAContext methodsFor: 'add' stamp: 'AlvaroJosePeraltaOcampo 3/30/2015 13:47'!
addAllElements: lst
	lst do: [ :p | self addElement: p ]! !

!A4BPSOAContext methodsFor: 'add' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 16:07'!
addElement: el
	lstElements at: el id put: el.
	el parent: self
			! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcamop 6/3/2015 14:51'!
allChildrens
	^ self allElements ! !

!A4BPSOAContext methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 3/3/2015 13:07'!
allElements
	|lst|
	lst:= OrderedCollection new.
	lstElements do:[ :e | lst addAll: e childrens]. 
	^ lst! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 2/17/2016 11:26'!
allNodes
	|lst|
	lst:= OrderedCollection new.
	self lstElements do:[ :e | lst addAll: e allNodes]. 
	^ lst! !

!A4BPSOAContext methodsFor: 'creator' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 10:25'!
buildRelations
	lstElements copy do: [ :e1 | lstElements do: [ :e2 | e1 buildRelations: e2 ] ].! !

!A4BPSOAContext methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/10/2014 23:42'!
childrens
	^ childrens! !

!A4BPSOAContext methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 09:00'!
childrens: achildrens
	^ childrens := achildrens! !

!A4BPSOAContext methodsFor: 'creator' stamp: 'AlvaroJosePeraltaOcampo 4/6/2016 23:13'!
configName: afr
	aName := afr basename! !

!A4BPSOAContext methodsFor: 'creator' stamp: 'AlvaroJosePeraltaOcampo 4/6/2016 23:07'!
createBaseOnPath: aString
	"create a soa world base on path of file system"

	| afr files parsers |
	afr := aString asFileReference.
	self configName: afr.
	parsers := self getParsers.
	parsers
		do: [ :parser | 
			parser filePrefix 
			do:[ :filep | 
				
				files := afr allFiles select: [ :each | each basename endsWith: filep ].
				files 
				do: [ :file | parser parseFile: file ].
				].
			parser addInContext: self 
			].
	self buildRelations! !

!A4BPSOAContext methodsFor: 'dsl' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 12:58'!
elements
	^ self lstElements ! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 23:08'!
getChildrenNodes
	| lst g unparsers|
	lst := OrderedCollection new.
	g := A4BPElementGroup new.
	g aName:'Process'.
	g addElements:  (self lstElements select:[ :e | e isProcess]).
	lst add: g.
	g := A4BPElementGroup new.
	g aName:'Services'.
	g addElements:  (self lstElements select:[ :e | e isWSDL]).
	lst add: g.
	g := A4BPElementGroup new.
	g aName:'Schemas'.
	g addElements:  (self lstElements select:[ :e | e isSchema]).
	lst add: g.
	
	unparsers := (self lstElements select:[ :e | e isUnparseObj]).

	unparsers size > 0 ifTrue:[	
		g := A4BPElementGroup new.
		g aName:'Unparse Elements'.
		g addElements: unparsers .
		lst add: g.
	].
	
	^ lst! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 09:42'!
getElementAtName: anName
	|lst|
	lst := (lstElements select:[:e | e aName = anName ]) values.
	lst size < 1 ifTrue:[ ^ A4BPEmptyObj instance].
	^  lst first.! !

!A4BPSOAContext methodsFor: 'creator' stamp: 'AlvaroJosePeraltaOcampo 3/6/2015 08:05'!
getParsers
	"Throw a new collection to use in the overwrite object to list the parse objects for the Context"

	^ OrderedCollection new! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 09:41'!
getProcessAtName: anName
	|lst|
	lst := (lstElements select:[:e | e aName = anName and: e isProcess. ]) values.
	lst size < 1 ifTrue:[ ^ A4BPEmptyObj instance].
	^  lst first.
! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 09:42'!
getWSDLAtName: anName
	|lst|
	lst := (lstElements select:[:e | e aName = anName and: e isWSDL. ]) values.
	lst size < 1 ifTrue:[ ^ A4BPEmptyObj instance].
	^  lst first.
! !

!A4BPSOAContext methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 12:37'!
initialize
	super initialize.
	lstElements := Dictionary new.
	aName := self hash asString! !

!A4BPSOAContext methodsFor: 'creator' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 10:26'!
joinContext: aContext
	lstElements addAll: aContext lstElements.! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 12/10/2014 23:42'!
lstElements
	^ lstElements! !

!A4BPSOAContext methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 09:00'!
lstElements: alstElements
	^ lstElements := alstElements! !

!A4BPSOAContext methodsFor: 'metrics' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 09:32'!
numberOfElements
	^ lstElements size! !

!A4BPSOAContext methodsFor: 'metrics' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 09:32'!
numberOfProcess
  ^ (lstElements collect:[:e | e isProcess ]) size.! !

!A4BPSOAContext methodsFor: 'metrics' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 10:31'!
numberOfSchemas
	^ self schemas size.! !

!A4BPSOAContext methodsFor: 'metrics' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 10:31'!
numberOfWSDLs
	^ self wsdls size.! !

!A4BPSOAContext methodsFor: 'dsl' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 12:37'!
process
	^ lstElements values select:[ :el | el isProcess].! !

!A4BPSOAContext methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 10:33'!
schemas
	^ (lstElements select:[:e | e isSchema ])! !

!A4BPSOAContext methodsFor: 'dsl' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 10:33'!
wsdls
	^ (lstElements select:[:e | e isWSDL ]).! !

A4BPObject subclass: #A4BPUnParserObj
	instanceVariableNames: 'tagName value fileName fullPath error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

A4BPUnParserObj class
	instanceVariableNames: 'instance'!

A4BPUnParserObj class
	instanceVariableNames: 'instance'!

!A4BPUnParserObj class methodsFor: 'instance' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:19'!
annotation
<MSEClass: #A4BPUnParserObj  super: #A4BPObject >
<package: #'A4BP-core' >! !

!A4BPUnParserObj class methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 09:58'!
endfromXMLDescription: document in: parent
	| aBPObj |
	aBPObj := self new.
	aBPObj parent: parent.
	self fillBData: document in: aBPObj.
	^ aBPObj! !

!A4BPUnParserObj class methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 3/6/2015 07:58'!
fillElementsIn: aModel from: document
	| visitor |
	visitor := BPMN20ParserSetinA4BPUnParserObjVisitor new.
	visitor element: aModel.
	aModel tagName: document name.
	self fillElementsIn: aModel from: document visitor: visitor.! !

!A4BPUnParserObj class methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 10:05'!
fillElementsIn: aBPObject from: document visitor: visitor tagRef: aTagRef
	| bpElement refTag typeName nodes |
	[ 
	nodes := document nodes nodes
		do: [ :docAtr | 
			typeName := docAtr name.
			refTag := aTagRef getClassBPBaseOnTypeName: typeName.
			bpElement := refTag objclass fromXMLDescription: docAtr in: aBPObject.
			bpElement accept: visitor ] ]
		on: Error
		do: [ 
			typeName := document name.
			refTag := aTagRef getClassBPBaseOnTypeName: typeName.
			bpElement := refTag objclass endfromXMLDescription: document in: aBPObject.
			bpElement accept: visitor ]! !

!A4BPUnParserObj class methodsFor: 'instance' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 08:57'!
instance
	self halt.
	instance ifNil:[instance:=self new].
	instance aName:'Unparser Entity'.
	^ instance! !

!A4BPUnParserObj methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 10:07'!
accept: aVisitor
	^ aVisitor visitA4BPUnParserObj: self! !

!A4BPUnParserObj methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 14:46'!
allElements
	^ OrderedCollection new! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 14:46'!
bpwsdl
	^ nil! !

!A4BPUnParserObj methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 3/6/2015 11:43'!
buildInterRelations
	! !

!A4BPUnParserObj methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:38'!
buildRelations: aModel
	! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/10/2014 23:45'!
childrens
	^ childrens! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 09:03'!
childrens: achildrens
	^ childrens := achildrens! !

!A4BPUnParserObj methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 23:25'!
error
	^ error! !

!A4BPUnParserObj methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 23:25'!
error: anError
	error := anError! !

!A4BPUnParserObj methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:34'!
fileName
	^ fileName! !

!A4BPUnParserObj methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:34'!
fileName: anObject
	fileName := anObject! !

!A4BPUnParserObj methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:34'!
fullPath
	^ fullPath! !

!A4BPUnParserObj methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:34'!
fullPath: anObject
	fullPath := anObject! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 14:46'!
getChildrenNodes
	^ nil! !

!A4BPUnParserObj methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcamop 6/5/2015 09:25'!
haveLazyRefLikeAt: aRef
	^ false! !

!A4BPUnParserObj methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 08:39'!
initialize
	super initialize.
	aName := 'Empty'.
	childrens := OrderedCollection new.
	id := UUID new asString! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 14:46'!
isBPEmtyObj
 ^ true! !

!A4BPUnParserObj methodsFor: 'question' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 23:04'!
isUnparseObj
 ^ true! !

!A4BPUnParserObj methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 14:46'!
link
	^ self! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/10/2014 23:45'!
myDocument
	^ myDocument! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 09:03'!
myDocument: amyDocument
	^ myDocument := amyDocument! !

!A4BPUnParserObj methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcamop 6/2/2015 23:00'!
nameSpaces
	^ ''! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/10/2014 23:45'!
parent
	^ parent! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 09:03'!
parent: aparent
	^ parent := aparent! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/10/2014 23:45'!
state
	^ state! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 09:03'!
state: astate
	^ state := astate! !

!A4BPUnParserObj methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:34'!
tagName
	^ tagName! !

!A4BPUnParserObj methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:34'!
tagName1: anObject
	tagName := anObject! !

!A4BPUnParserObj methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/13/2015 11:44'!
tagName: value
	tagName := value.
	aName := value.! !

!A4BPUnParserObj methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcamop 6/5/2015 09:26'!
targetNamespace
	^ ''! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/10/2014 23:45'!
text
	^ text! !

!A4BPUnParserObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 09:03'!
text: atext
	^ text := atext! !

!A4BPUnParserObj methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/24/2015 09:03'!
v
	^ value! !

!A4BPUnParserObj methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 22:07'!
value: anValue
	value := anValue! !

Object subclass: #A4BPParserRefTagClass
	instanceVariableNames: 'tag objclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

!A4BPParserRefTagClass class methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 13:15'!
getRefOnTag: tag objClass: objclass
 	| instance |
	instance:= self new.
	instance tag:tag.
	instance objclass:objclass.
^ instance ! !

!A4BPParserRefTagClass methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/13/2015 19:25'!
isEmptyObj
	^ self objclass = A4BPEmptyObj.! !

!A4BPParserRefTagClass methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/13/2015 19:24'!
isUnParser
	^ self objclass = A4BPUnParserObj.! !

!A4BPParserRefTagClass methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 13:15'!
key
 ^ tag! !

!A4BPParserRefTagClass methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 13:15'!
objclass
^ objclass! !

!A4BPParserRefTagClass methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 13:15'!
objclass: aobjclass
	objclass := aobjclass! !

!A4BPParserRefTagClass methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 13:15'!
tag
 ^ tag! !

!A4BPParserRefTagClass methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 13:15'!
tag:atag
 tag:=atag.! !

Object subclass: #A4BPParserTagsXMLRef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

A4BPParserTagsXMLRef class
	instanceVariableNames: 'tags'!

A4BPParserTagsXMLRef class
	instanceVariableNames: 'tags'!

!A4BPParserTagsXMLRef class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:27'!
annotation
<abstract>
<MSEClass: #A4BPParserTagsXMLRef  super: #Object >
<package: #'A4BP-core' >! !

!A4BPParserTagsXMLRef class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 10:46'!
atrName
	'name'! !

!A4BPParserTagsXMLRef class methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 21:25'!
copyList: lstItems with: v
	"second model option bpmn:<tag>"
	lstItems copy do:[ :i |
		lstItems add: (A4BPParserRefTagClass getRefOnTag: ( v, i tag) objClass: (i objclass) ). 
	].
	
	^ lstItems! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 3/13/2015 23:44'!
fillItems: items tag: tag class: objClass
	| ref |
	ref := A4BPParserRefTagClass getRefOnTag: tag objClass: objClass.
	items at: ref key put: ref.! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 21:26'!
fillTags
	tags addAll: self lstOfRefTagClass.
	^ tags! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 22:05'!
getClassBPBaseOnTypeName: aTypeName
	[ ^ self lstOfBPTagClass at: aTypeName ]
		on: KeyNotFound
		do: [ ^ self lstOfBPTagClass at: A4BPUnParserObj name ]! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:31'!
getRef: aModel
	^ aModel accept: self! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 14:45'!
lstOfBPTagClass
	tags ifNil: [ tags := Dictionary new ].
	tags size > 0
		ifTrue: [ ^ tags ].
	self setEmptyObj: tags.
	self setUnParseObj: tags.
	self fillTags.
	^ tags! !

!A4BPParserTagsXMLRef class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 21:35'!
lstOfRefTagClass
	^ Dictionary new! !

!A4BPParserTagsXMLRef class methodsFor: 'resetting' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 13:17'!
reset
	"self reset"
	tags := nil.
	^ 'OK'! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 3/18/2015 22:05'!
setEmptyObj: items
	items add: (A4BPParserRefTagClass getRefOnTag: A4BPEmptyObj name asString objClass: A4BPEmptyObj).
	^ items! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 3/13/2015 19:22'!
setUnParseObj: items
	items add: (A4BPParserRefTagClass getRefOnTag: A4BPUnParserObj name asString objClass: A4BPUnParserObj).
	^ items! !

Object subclass: #A4BPPerspective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-metric'!

Object subclass: #A4BPResourceDownload
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-resources-download'!

!A4BPResourceDownload class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 15:16'!
baseDirectory
	^ FileSystem disk workingDirectory! !

!A4BPResourceDownload class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 15:16'!
getContentsFromURL: url
	| response |
	response := ZnClient new
		url: url;
		get;
		response.
	^ response contents! !

!A4BPResourceDownload class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 15:16'!
unzipContentIn: aDirectory with: contents
	| archive |
	archive := ZipArchive new.
	archive readFrom: contents readStream.
	archive extractAllTo: aDirectory! !

Object subclass: #A4BPXMLHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

!A4BPXMLHelper methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:47'!
dictionary
	^ Dictionary new! !

!A4BPXMLHelper methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 10:47'!
prefixMappings
	^ self! !

Object subclass: #BPMN20ParserSetinA4BPUnParserObjVisitor
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser-builder'!

!BPMN20ParserSetinA4BPUnParserObjVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/30/2014 18:38'!
element
	^ element! !

!BPMN20ParserSetinA4BPUnParserObjVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/30/2014 18:38'!
element: aElement
	^ element := aElement! !

!BPMN20ParserSetinA4BPUnParserObjVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/30/2014 18:39'!
visitA4BPEmptyObj: aModel
	element addChildren: aModel! !

!BPMN20ParserSetinA4BPUnParserObjVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 12/11/2014 10:10'!
visitA4BPUnParserObj: aModel
	element addChildren: aModel! !

!BPMN20ParserSetinA4BPUnParserObjVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/30/2014 18:40'!
visitBPObject: aModel
	element addChildren: aModel! !

Object subclass: #FileSeparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-files'!

FileSeparator class
	instanceVariableNames: 'separator cseparator'!

FileSeparator class
	instanceVariableNames: 'separator cseparator'!

!FileSeparator class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 15:56'!
cseparator
	cseparator ifNil:[ 
		(((Smalltalk os isMacOS) or:(Smalltalk os isMacOSX))or:(Smalltalk os isUnix))
		ifTrue:[
			cseparator := $/.
			].
		(Smalltalk os isWindows)
		ifTrue:[
			cseparator := $\.
			].
	].
	
	^ cseparator! !

!FileSeparator class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 15:55'!
separator
	separator ifNil:[ 
		(((Smalltalk os isMacOS) or:(Smalltalk os isMacOSX))or:(Smalltalk os isUnix))
		ifTrue:[
			separator := '/'.
			cseparator := $/.
			].
		(Smalltalk os isWindows)
		ifTrue:[
			separator := '\'.
			cseparator := $\.
			].
	].
	
	^ separator! !
